## vacuum-1.2.4.tar.gz

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)

project(vacuum-im)

find_package(Qt4 REQUIRED)

add_custom_target(updatets)

include("config.cmake")

install(DIRECTORY "resources/menuicons"
	DESTINATION "${INSTALL_RESOURCES}"
	PATTERN ".svn" EXCLUDE)

include("package.cmake")

set(INSTALL_SDK YES CACHE BOOL "Install files needed to build custom plugins")
set(INSTALL_DOCS YES CACHE BOOL "Install documentation (currently it's only AUTHORS, CHANGELOG, README and COPYING)")
set(LANGS "" CACHE STRING "List of languages to build localization for (this variable overrides any of LANG_*)")
set(USED_LANGS "" CACHE INTERNAL "List of languages actually used for generating targets")
add_lang_options()

set(FORCE_BUNDLED_MINIZIP NO CACHE BOOL "Use bundled minizip even if local system have one")

find_library(SYSTEM_ZLIB_FOUND z)
find_library(SYSTEM_IDN_FOUND idn)
find_library(SYSTEM_MINIZIP_FOUND minizip)
find_library(SYSTEM_QTLOCKEDFILE_FOUND QtSolutions_LockedFile-2.4)

if (FORCE_BUNDLED_MINIZIP)
	set(SYSTEM_MINIZIP_FOUND NO)
endif (FORCE_BUNDLED_MINIZIP)

if (SYSTEM_ZLIB_FOUND)
	add_definitions(-DUSE_SYSTEM_ZLIB)
endif (SYSTEM_ZLIB_FOUND)

if (SYSTEM_IDN_FOUND)
	add_definitions(-DUSE_SYSTEM_IDN)
endif (SYSTEM_IDN_FOUND)

if (SYSTEM_MINIZIP_FOUND)
	add_definitions(-DUSE_SYSTEM_MINIZIP)
endif (SYSTEM_MINIZIP_FOUND)

if (SYSTEM_QTLOCKEDFILE_FOUND)
	add_definitions(-DUSE_SYSTEM_QTLOCKEDFILE)
endif (SYSTEM_QTLOCKEDFILE_FOUND)


if ("${LANGS}" STREQUAL "")
	process_lang_options()
else ("${LANGS}" STREQUAL "")
	set_enabled_langs("${LANGS}")
endif ("${LANGS}" STREQUAL "")

if (INSTALL_DOCS)
	install(FILES "AUTHORS" "CHANGELOG" "README" "COPYING" "TRANSLATORS"
		DESTINATION "${INSTALL_DOCUMENTS}")
endif (INSTALL_DOCS)

add_subdirectory(src)

# runtime deps on Windows
if (WIN32)
	set(WEBKIT_WITHOUT_PHONON NO CACHE BOOL "Turn this flag ON if you use QtWebKit built without Phonon support")
	set(WEBKIT_WITHOUT_XMLPATTERNS NO CACHE BOOL "Turn this flag ON if you use QtWebKit built without QtXmlPatterns")
	cpack_add_component_group(libs
		DISPLAY_NAME "Shared libraries"
		DESCRIPTION "Required libraries that already may be present in your system")
	set(QT_LIBS "${QT_LIBRARY_DIR}/../bin/QtCore4.dll"
		"${QT_LIBRARY_DIR}/../bin/QtGui4.dll"
		"${QT_LIBRARY_DIR}/../bin/QtNetwork4.dll"
		"${QT_LIBRARY_DIR}/../bin/QtXml4.dll"
		"${QT_LIBRARY_DIR}/../bin/QtWebkit4.dll")
	if (NOT WEBKIT_WITHOUT_PHONON)
		set(QT_LIBS ${QT_LIBS} "${QT_LIBRARY_DIR}/../bin/phonon4.dll")
	endif (NOT WEBKIT_WITHOUT_PHONON)
	if (NOT WEBKIT_WITHOUT_XMLPATTERNS)
		set(QT_LIBS ${QT_LIBS} "${QT_LIBRARY_DIR}/../bin/QtXmlPatterns4.dll")
	endif (NOT WEBKIT_WITHOUT_XMLPATTERNS)
	install(FILES ${QT_LIBS}
		DESTINATION "."
		COMPONENT qt_libs)
	install(DIRECTORY "${QT_PLUGINS_DIR}/imageformats"
		DESTINATION "."
		COMPONENT qt_libs
		FILES_MATCHING
		PATTERN "*.dll"
		PATTERN "*d4.dll" EXCLUDE)
	cpack_add_component(qt_libs
		DISPLAY_NAME "Qt4 libraries"
		DESCRIPTION "May be unchecked if you already have working Qt4 installation"
		GROUP libs)
	# Qt localization
	foreach(LANG ${LOCALIZED_LANGS})
		string(SUBSTRING ${LANG} 0 2 SHORTLANG)
		install(FILES "${QT_TRANSLATIONS_DIR}/qt_${SHORTLANG}.qm"
			DESTINATION "${INSTALL_TRANSLATIONS}/${LANG}"
			COMPONENT qt_${LANG})
		cpack_add_component(qt_${LANG}
			DISPLAY_NAME "Qt4 translation"
			GROUP ${LANG}_translation
			DEPENDS qt_libs)
	endforeach(LANG)

	install(FILES "libeay32.dll" "ssleay32.dll"
		DESTINATION "."
		COMPONENT openssl_libs)
	cpack_add_component(openssl_libs
		DISPLAY_NAME "OpenSSL libraries"
		DESCRIPTION "May be unchecked if you already have OpenSSL installed"
		GROUP libs)

	if (MINGW)
		install(FILES "mingwm10.dll" "libgcc_s_dw2-1.dll"
			DESTINATION "."
			COMPONENT mingw_runtime)
		cpack_add_component(mingw_runtime
			DISPLAY_NAME "MinGW runtime libraries"
			DESCRIPTION "May be unchecked if you already have MinGW installed"
			GROUP libs)
	elseif (MSVC)
		# TODO: check these patterns
		file(GLOB MSVC_DLLS "msvc*.dll")
		file(GLOB MANIFEST "Microsoft.VC*.CRT.manifest")
		install(FILES ${MSVC_DLLS} ${MANIFEST}
			DESTINATION "."
			COMPONENT msvc_runtime)
		cpack_add_component(msvc_runtime
			DISPLAY_NAME "MSVC runtime libraries"
			DESCRIPTION "May be unchecked if you already have MS Visual C++ or it's redistributable package installed"
			GROUP libs)
	endif (MINGW)
endif (WIN32)

if (INSTALL_SDK)
	cpack_add_component(sdk
		DISPLAY_NAME "SDK"
		DESCRIPTION "Files needed to build custom plugins"
		DISABLED)
endif (INSTALL_SDK)

=== src/CMakeLists.txt ===
add_subdirectory(thirdparty)
add_subdirectory(utils)
add_subdirectory(loader)
add_subdirectory(plugins)
add_subdirectory(definitions)
add_subdirectory(interfaces)

=== src/definitions/CMakeLists.txt ===
file(GLOB HEADERS "*.h")

if (INSTALL_SDK)
	install(FILES ${HEADERS}
		DESTINATION "${INSTALL_INCLUDES}/definitions"
		COMPONENT sdk)
endif (INSTALL_SDK)

=== src/interfaces/CMakeLists.txt ===
file(GLOB HEADERS "*.h")

if (INSTALL_SDK)
	install(FILES ${HEADERS}
		DESTINATION "${INSTALL_INCLUDES}/interfaces"
		COMPONENT sdk)
endif (INSTALL_SDK)

=== src/loader/CMakeLists.txt ===
# needed for translations.cmake to correctly generate CPack components
set(PLUGIN_NAME ${TARGET_LOADER})
set(PLUGIN_DISPLAY_NAME "loader")

include("${CMAKE_SOURCE_DIR}/config.cmake")
include("loader.cmake")

project(loader CXX)

include_directories("${CMAKE_SOURCE_DIR}/src" "${CMAKE_BINARY_DIR}/src/loader")
set(QT_USE_QTXML YES)
set(QT_USE_QTMAIN YES)
include(${QT_USE_FILE})

set(VER_STRING "" CACHE STRING "This string will be appended to program version (defaults to SVN revision number)")

if (VER_STRING STREQUAL "")
execute_process(COMMAND svnversion -n -c "${CMAKE_SOURCE_DIR}"
	OUTPUT_VARIABLE SVN_REVISION)
else (VER_STRING STREQUAL "")
	set(SVN_REVISION "0:${VER_STRING}") # see PluginManager::revision()
endif (VER_STRING STREQUAL "")

if (NOT (SVN_REVISION STREQUAL "" OR SVN_REVISION STREQUAL "exported" OR SVN_REVISION STREQUAL "Unversioned directory")) 
	file(REMOVE "svninfo.h")
	file(WRITE "svninfo.h" "#define SVN_REVISION \"${SVN_REVISION}\"\n")
	add_definitions(-DSVNINFO)
endif (NOT (SVN_REVISION STREQUAL "" OR SVN_REVISION STREQUAL "exported" OR SVN_REVISION STREQUAL "Unversioned directory")) 

if (WIN32)
	if (MINGW)
		add_custom_command(OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/loader.rc.obj"
			COMMAND windres.exe
				"-I${CMAKE_CURRENT_SOURCE_DIR}"
				"-i${CMAKE_CURRENT_SOURCE_DIR}/loader.rc"
				-o "${CMAKE_CURRENT_BINARY_DIR}/loader.rc.obj")
		set(SOURCES ${SOURCES} "${CMAKE_CURRENT_BINARY_DIR}/loader.rc.obj")
	else (MINGW)
		set(SOURCES ${SOURCES} "loader.rc")
	endif (MINGW)
endif (WIN32)

add_translations(TRANSLATIONS "${TARGET_LOADER}" ${SOURCES} ${UIS})
add_executable(${TARGET_LOADER} WIN32 ${SOURCES} ${MOC_SOURCES} ${UI_HEADERS} ${TRANSLATIONS})
set_target_properties(${TARGET_LOADER} PROPERTIES RUNTIME_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}")
target_link_libraries(${TARGET_LOADER} ${TARGET_UTILS} ${QT_LIBRARIES})

install(TARGETS ${TARGET_LOADER}
	RUNTIME	DESTINATION "${INSTALL_BINS}"
	COMPONENT ${TARGET_LOADER})
if (UNIX AND NOT APPLE AND NOT HAIKU)
	install(FILES "${CMAKE_SOURCE_DIR}/resources/menuicons/shared/vacuum.png"
		DESTINATION "${INSTALL_RES_DIR}/pixmaps")
	install(FILES "${CMAKE_SOURCE_DIR}/src/packages/linux/vacuum.desktop"
		DESTINATION "${INSTALL_RES_DIR}/applications")
endif (UNIX AND NOT APPLE AND NOT HAIKU)

cpack_add_component(${TARGET_LOADER}
	DISPLAY_NAME "Loader"
	REQUIRED
	GROUP core)

=== src/plugins/CMakeLists.txt ===
set(ALL_PLUGINS "")

include("plugin_list.cmake")

list(REMOVE_DUPLICATES ALL_PLUGINS)

# Check dependencies
foreach(plugin ${ALL_PLUGINS})
	if (PLUGIN_${plugin})
		foreach(dep ${${plugin}_DEPENDENCIES})
			if (NOT PLUGIN_${dep})
				message(WARNING "Plugin '${plugin}' requires '${dep}', but it is disabled. Please, set PLUGIN_${dep} to ON, unless you know what you are doing.")
			endif (NOT PLUGIN_${dep})
		endforeach(dep)
	endif (PLUGIN_${plugin})
endforeach(plugin)

=== src/thirdparty/CMakeLists.txt ===
if (NOT SYSTEM_MINIZIP_FOUND)
	add_subdirectory(minizip)
endif (NOT SYSTEM_MINIZIP_FOUND)
if (NOT SYSTEM_IDN_FOUND)
	add_subdirectory(idn)
endif (NOT SYSTEM_IDN_FOUND)
if (NOT SYSTEM_QTLOCKEDFILE_FOUND)
	add_subdirectory(qtlockedfile)
endif (NOT SYSTEM_QTLOCKEDFILE_FOUND)
add_subdirectory(jdns)
add_subdirectory(qxtglobalshortcut)
add_subdirectory(idle)
if (NOT SYSTEM_ZLIB_FOUND)
	add_subdirectory(zlib)
endif (NOT SYSTEM_ZLIB_FOUND)

=== src/utils/CMakeLists.txt ===
# needed for translations.cmake to correctly generate CPack components
set(PLUGIN_NAME ${TARGET_UTILS})
set(PLUGIN_DISPLAY_NAME "utils library")

include("${CMAKE_SOURCE_DIR}/config.cmake")
include("utils.cmake")

project(${TARGET_UTILS})

set(QT_USE_QTXML YES)
set(QT_USE_QTNETWORK YES)
include(${QT_USE_FILE})

add_definitions("-DUTILS_DLL")
add_definitions("-DQXT_STATIC") 
link_directories("${CMAKE_BINARY_DIR}/libs")
include_directories(AFTER "${CMAKE_SOURCE_DIR}/src/thirdparty/zlib")
include(FindX11)
include_directories(AFTER ${X11_INCLUDE_DIR})
if (NOT SYSTEM_IDN_FOUND)
	include_directories("${CMAKE_SOURCE_DIR}/src/thirdparty/idn")
endif (NOT SYSTEM_IDN_FOUND)

add_translations(TRANSLATIONS "${TARGET_UTILS}" ${SOURCES})
add_library(${TARGET_UTILS} SHARED ${SOURCES} ${MOC_SOURCES} ${TRANSLATIONS})
set_target_properties(${TARGET_UTILS} PROPERTIES
	VERSION "${VERSION_UTILS}"
	SOVERSION "${VERSION_UTILS_ABI}")

set(ADD_LIBS qxtglobalshortcut idle)
if (SYSTEM_ZLIB_FOUND)
	list(APPEND ADD_LIBS "${SYSTEM_ZLIB_FOUND}")
else (SYSTEM_ZLIB_FOUND)
	list(APPEND ADD_LIBS zlib)
endif (SYSTEM_ZLIB_FOUND)

if (SYSTEM_IDN_FOUND)
	list(APPEND ADD_LIBS "${SYSTEM_IDN_FOUND}")
else (SYSTEM_IDN_FOUND)
	list(APPEND ADD_LIBS idn)
endif (SYSTEM_IDN_FOUND)

if (SYSTEM_MINIZIP_FOUND)
	list(APPEND ADD_LIBS "${SYSTEM_MINIZIP_FOUND}")
else (SYSTEM_MINIZIP_FOUND)
	list(APPEND ADD_LIBS minizip)
endif (SYSTEM_MINIZIP_FOUND)


if (X11_Xscreensaver_FOUND)
	message(STATUS "Found Xscreensaver: ${X11_Xscreensaver_LIB}")
	list(APPEND ADD_LIBS "${X11_Xscreensaver_LIB}")
else (X11_Xscreensaver_FOUND)
	message(STATUS "Xscreensaver not found")
endif (X11_Xscreensaver_FOUND)

if (APPLE)
	list(APPEND ADD_LIBS "-framework Carbon")
endif (APPLE)

target_link_libraries(${TARGET_UTILS} LINK_INTERFACE_LIBRARIES ${QT_LIBRARIES})
target_link_libraries(${TARGET_UTILS} ${QT_LIBRARIES} ${ADD_LIBS})

if (WIN32)
	set_target_properties(${TARGET_UTILS} PROPERTIES RUNTIME_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}")
	install(TARGETS ${TARGET_UTILS}
		RUNTIME DESTINATION "${INSTALL_LIBS}"
		COMPONENT ${TARGET_UTILS})
else (WIN32)
	set_target_properties(${TARGET_UTILS} PROPERTIES LIBRARY_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/src/libs")
	install(TARGETS ${TARGET_UTILS}
		LIBRARY DESTINATION "${INSTALL_LIBS}"
		COMPONENT ${TARGET_UTILS})
endif (WIN32)

cpack_add_component(${TARGET_UTILS}
	DISPLAY_NAME "Utils library"
	REQUIRED
	GROUP core)

if (INSTALL_SDK)
	file(GLOB ALL_HEADERS "*.h")
	install(FILES ${ALL_HEADERS}
		DESTINATION "${INSTALL_INCLUDES}/utils"
		COMPONENT sdk)
	if (WIN32)
		install(TARGETS ${TARGET_UTILS}
			ARCHIVE DESTINATION "${INSTALL_LIBS}"
			COMPONENT sdk)
	endif (WIN32)
endif (INSTALL_SDK)

=== src/plugins/accountmanager/CMakeLists.txt ===
project(accountmanager)

set(PLUGIN_NAME "accountmanager")
set(PLUGIN_DISPLAY_NAME "Account manager")
set(PLUGIN_DEPENDENCIES xmppstreams) # used only in CPack
set(${PLUGIN_NAME}_IS_ESSENTIAL YES)

include("accountmanager.cmake")
include("${CMAKE_SOURCE_DIR}/plugins.cmake")

=== src/plugins/adiummessagestyle/CMakeLists.txt ===
project(adiummessagestyle)

set(PLUGIN_NAME "adiummessagestyle")
set(PLUGIN_DISPLAY_NAME "Adium message style")
set(QT_USE_QTWEBKIT YES)
set(QT_USE_PHONON NO)
set(QT_USE_QTXMLPATTERNS NO)

include("adiummessagestyle.cmake")
include("${CMAKE_SOURCE_DIR}/plugins.cmake")

if (IS_ENABLED)
	install(DIRECTORY "${CMAKE_SOURCE_DIR}/resources/adiummessagestyles"
		DESTINATION "${INSTALL_RESOURCES}"
		COMPONENT ${PLUGIN_NAME}
		PATTERN ".svn" EXCLUDE)
endif (IS_ENABLED)

=== src/plugins/annotations/CMakeLists.txt ===
project(annotations)

set(PLUGIN_NAME "annotations")
set(PLUGIN_DISPLAY_NAME "Annotations")
set(PLUGIN_DEPENDENCIES privatestorage) # used only in CPack

include("annotations.cmake")
include("${CMAKE_SOURCE_DIR}/plugins.cmake")

=== src/plugins/autostatus/CMakeLists.txt ===
project(autostatus)

set(PLUGIN_NAME "autostatus")
set(PLUGIN_DISPLAY_NAME "Autostatus")
set(PLUGIN_DEPENDENCIES statuschanger accountmanager) # used only in CPack

include("autostatus.cmake")
include("${CMAKE_SOURCE_DIR}/plugins.cmake")

=== src/packages/linux/debian/control ===
Source: vacuum
Section: net
Priority: optional
Maintainer: Sergey A Potapov <potapov.s.a@gmail.com>
Build-Depends: cmake, debhelper (>= 7.0.50~), openssl, libqtwebkit-dev | libqt4-dev, libx11-dev, zlib1g-dev, libidn11-dev
Standards-Version: 3.9.1
Homepage: http://code.google.com/p/vacuum-im/

Package: vacuum
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: nas
Description: Jabber client using Qt
 Vacuum is a free instant messaging application designed for the Jabber
 (XMPP) IM network (including Google Talk). It has full Unicode support, 
 and supports most important XMPP features.

Package: vacuum-dev
Architecture: all
Depends: ${misc:Depends}, vacuum
Description: Development files for Vacuum
 This package contains Vacuum include files you need if you
 want to develop plugins for Vacuum.

=== src/packages/linux/debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE=1

REV=$(shell dpkg-parsechangelog | awk '/^Version: / {print $$2}' | sed 's/.*svn//' | sed 's/-.*//')

override_dh_auto_configure:
	dh_auto_configure -- -DVER_STRING=$(REV) -DCMAKE_BUILD_TYPE=Release

override_dh_install:
	dh_install --list-missing -XCOPYING -Xlicense.txt
	for size in 16 24 32 48 64 96 128 ; do \
	mkdir -p $(CURDIR)/debian/vacuum/usr/share/icons/hicolor/$${size}x$${size}/apps/ && install -Dm644 $(CURDIR)/resources/menuicons/shared/mainwindowlogo$${size}.png $(CURDIR)/debian/vacuum/usr/share/icons/hicolor/$${size}x$${size}/apps/vacuum.png ; \
	done

%:
	dh $@ --parallel
